---
title: WebVR concepts
slug: Web/API/WebVR_API/Concepts
tags:
  - Acceleration
  - Apps
  - FOV
  - Guide
  - Orientation
  - Position
  - VR
  - Virtual Reality
  - WebVR
  - concepts
  - velocity
---
<div>{{APIRef("WebVR API")}}{{deprecated_header}}</div>

<div class="notecard note"><strong>Note:</strong> WebVR API is replaced by <a href="/en-US/docs/Web/API/WebXR_API">WebXR API</a>. WebVR was never ratified as a standard, was implemented and enabled by default in very few browsers and supported a small number of devices.</div>

<p class="summary">This article discusses some of the concepts and theory behind virtual reality (VR). If you are a newcomer to the area, it is worthwhile getting an understanding of these topics before you start diving into code.</p>

<h2 id="The_history_of_VR">The history of VR</h2>

<p>Virtual reality is nothing new — the concept goes way further back than the Oculus Rift Kickstarter campaign of 2012. People have been experimenting with it for decades.</p>

<p>In 1939 the <a href="https://en.wikipedia.org/wiki/View-Master">View-Master device</a> was created, allowing people to see 3D pictures. The device displayed images stored on cardboard disks containing stereoscopic 3D pairs of small color photographs. After years of development the military got interested in using such technology, and Project Headsight was born in 1961 — this involved a helmet incorporating a video screen with a head-tracking system.</p>

<p><img alt="" src="http://end3r.com/tmp/vr/view-master.jpg" style="display: block; margin: 0px auto;"></p>

<p>There were various experiments conducted over the next few decades, but it wasn't resricted to science labs and battlefields anymore. Eventually pop culture took over with movie directors showing their visions of virtual reality. Movies like Tron (1982) and The Matrix (1999) were created, where people could transfer themselves into a whole new cyber world or were trapped in one without even knowing, accepting it as the real world.</p>

<p><img alt="" src="http://end3r.com/tmp/vr/matrix.jpg" style="display: block; margin: 0px auto;"></p>

<p>The first VR gaming attempts were big and expensive — in 1991 Virtuality Group created a VR-ready arcade machine with goggles and ported popular titles like Pac-Man to virtual reality. Sega introduced their VR glasses at the Consumer Electronics Show in 1993. Companies were experimenting, but the market and consumers weren't convinced — we had to wait until 2012 to see a real example of a successful VR project.</p>

<h3 id="VR_in_recent_times">VR in recent times</h3>

<p>So what's new? Virtual Reality hardware needs to deliver high-precision, low-latency data to deliver an acceptable user experience; computers running VR applications need to be powerful enough to handle all this information. It has not been until recently that such accuracy and power has been available at an afforable cost, if at all. Early VR prototypes cost tens of thousands of dollars, whereas more recent headsets such as the <a href="https://www.vive.com/uk/">HTC VIVE</a> and <a href="https://www.oculus.com/rift/">Oculus Rift</a> are available for hundreds of dollars, and cheaper solutions are available — mobile device-based solutions like <a href="http://www.samsung.com/global/galaxy/gear-vr/">Gear VR</a> and <a href="https://www.google.com/get/cardboard/">Google Cardboard</a>.</p>

<p>On the software side, Valve has created <a href="http://store.steampowered.com/universe/vr">SteamVR</a> software, which is compatible with the VIVE and other solutions, and serves to provide access to software, such as a usable VR UI.</p>

<p>The technology itself is here, and the more expensive headsets will only get cheaper over time so more people can experience virtual reality on their own in the future.</p>

<h3 id="Input_devices">Input devices</h3>

<p>Handling input for virtual reality applications is an interesting topic — it's a totally new experience for which dedicated user interfaces have to be designed. There are various approaches right now from classic keyboard and mouse, to new ones like Leap Motion and the VIVE controllers. It's a matter of trial and error to see what works in given situations and what inputs fit best for your type of game.</p>

<p><img alt="" src="http://end3r.com/tmp/vr/oculus-touch.jpg" style="display: block; margin: 0px auto;"></p>

<h2 id="VR_Hardware_setup" style="line-height: 30px; font-size: 2.14285714285714rem;">VR Hardware setup</h2>

<p>There are two main types of setup, mobile or computer-connected. Their minimum hardware set ups are as follows:</p>

<ul>
 <li>Mobile: A Head-mounted display (HMD) is created using a smartphone — which acts as the VR display — mounted in a VR mount such as Google Cardboard, which contains the required lenses to provide stereoscopic vision of what is projected on the mobile screen.<img alt="Mobile based VR setup" src="https://mdn.mozillademos.org/files/11085/mobileBasedVRSetup.png" style="width: 100%;"></li>
 <li>Computer-connected: A VR setup is connected to your computer — this consists of a Head Mounted Display (HMD) containing a high resolution landscape-oriented screen onto which the visuals for both the left and right eye are displayed, which also includes a lens for each eye to promote separation of the left and right eye scene (stereoscopic vision.) The setup also includes a separate position sensor that works out the position/orientation/velocity/acceleration of your head and constantly passes that information the computer. <img alt="Computer based VR Setup" src="https://mdn.mozillademos.org/files/11089/computerBasedVRSetup.png" style="width: 100%;"></li>
</ul>

<div class="note">
<p><strong>Note</strong>: Computer-connected systems sometimes don't include a position sensor, but they usually do.</p>
</div>

<p>Other hardware that complements the VR experience includes:</p>

<ul>
 <li><strong>A hand recognition sensor</strong>: A sensor that tracks the position and movement of your hand, allowing it to become an interesting controller, and an object in VR gameworlds. The most advanced to date is the <a href="https://www.leapmotion.com/">Leap Motion</a>, which works with the computer (connected to the Oculus Rift) and can also work connected to a mobile device (the latter is in an experimental phase.)</li>
 <li><strong>A gamepad</strong>: We can configurate an XBox controller or similar to work as a keyboard in the browser — this offers further possibilities of interaction with a VR webpage. There are some gamepads that work with a mobile setup — like the <a href="http://www.mergevr.com/">MergeVR headset</a> — but these are connected via Bluetooth so don't work with WebVR. </li>
 <li><strong>An eye tracking sensor (experimental)</strong>: The FOVE project is the first headset that reads subtle eye movements.</li>
 <li><strong>A facial expression tracker (experimental)</strong>: Researchers at the University of Southern California and Facebook’s Oculus division have been testing new ways of tracking facial expressions and transferring them to a virtual character.</li>
 <li><strong>A more complex positional sensor system</strong>: As an example, the HTC VIVE features two position sensors that sit in opposite corners of a space, mapping it all out and allowing VR experiences to be enjoyed in spaces of up to 5m x 5m.</li>
</ul>

<h2 id="Position_and_orientation_velocity_and_acceleration">Position and orientation, velocity and acceleration</h2>

<p>As mentioned above, the position sensor detects information concerning the HMD and constantly outputs it, allowing you to continually update a scene according to head movement, rotation, etc. But what exactly is the information?</p>

<p><img alt="Position and Orientation VR setup" src="https://mdn.mozillademos.org/files/11083/positionOrientationVR.png" style="width: 100%;"></p>

<p>The output information falls into four categories:</p>

<ol>
 <li>Position — The position of the HMD along three axes in a 3D coordinate space. x is to the left and right, y is up and down, and z is towards and away from the position sensor. In WebVR, the x, y, and z coordinates are represented by the array contained in {{domxref("VRPose.position")}}.</li>
 <li>Orientation — The rotation of the HMD around three axes in a 3D coordinate space. Pitch is rotation around the x axis, yaw is rotation around the y axis, and roll is rotation around the z axis. In WebVR, the pitch, yaw, and roll are represented by the first three elements of the array contained in {{domxref("VRPose.orientation")}}.</li>
 <li>Velocity — There are two types of velocity to consider in VR:
  <ul>
   <li>Linear — The speed along any one of the axes that the HMD is traveling. This information can be accessed using {{domxref("VRPose.linearVelocity")}}.</li>
   <li>Angular — The speed at which the HMD is rotating around any one of the axes. This information can be accessed using {{domxref("VRPose.angularVelocity")}}.</li>
  </ul>
 </li>
 <li>Acceleration — There are two types of acceleration to consider in VR:
  <ul>
   <li>Linear — The acceleration of travel along any one of the axes that the HMD is traveling. This information can be accessed using {{domxref("VRPose.linearAcceleration")}}.</li>
   <li>Angular — The acceleration of rotation of the HMD around any one of the axes. This information can be accessed using {{domxref("VRPose.angularAcceleration")}}.</li>
  </ul>
 </li>
</ol>

<h2 id="Field_of_view">Field of view</h2>

<p>The field of view (FOV) is the area that each of the user's eyes can reasonably be expected to see. It roughly takes the form of a pyramid shape, laid down on one side, with the apex inside the user's head, and the rest of the pyramid eminating from the user's eye. Each eye has it's own FOV, one slightly overlapping the other.</p>

<p><img alt="FOV related properties" src="https://mdn.mozillademos.org/files/11091/FOVrelatedProperties.png" style="width: 100%;"></p>

<p>The FOV is defined by the following values:</p>

<ul>
 <li>{{domxref("VRFieldOfView.upDegrees")}}: The number of degrees upwards that the field of view extends in.</li>
 <li>{{domxref("VRFieldOfView.rightDegrees")}}: The number of degrees to the right that the field of view extends in.</li>
 <li>{{domxref("VRFieldOfView.downDegrees")}}: The number of degrees downwards that the field of view extends in.</li>
 <li>{{domxref("VRFieldOfView.leftDegrees")}}: The number of degrees to the left that the field of view extends in.</li>
 <li>zNear, defined by {{domxref("VRDisplay.depthNear")}}: The distance from the middle of the user's head to the start of the visible FOV.  </li>
 <li>zFar, defined by {{domxref("VRDisplay.depthFar")}}: The distance from the middle of the user's head to the end of the visible FOV.</li>
</ul>

<p>The default values for these properties will differ slightly by VR hardware, although they tend to be around 53° up and down, and 47° left and right, with zNear and zFar coming in at around 0.1m and 10000m respectively.</p>

<div class="note">
<p><strong>Note</strong>: The user can potentially see all the way around them, which is a brand new concept for apps and games. Try to give people a reason to look around and see what's behind them — make them reach out and find things that are not visible at the very beginning. Describe what's behind their backs.</p>
</div>

<h2 id="Concepts_for_VR_apps">Concepts for VR apps</h2>

<p>This section discusses concepts to be aware of when developing VR apps that you've probably not had to consider before when developing regular apps for mobile or desktop.</p>

<h3 id="Stereoscopic_vision">Stereoscopic vision</h3>

<p>Stereoscopic vision is the normal vision humans and (most) animals have — <span class="hvr">the</span> <span class="hvr">perception</span> of two <span class="hvr">slightly</span> <span class="hvr">differing</span> <span class="hvr">images</span> (one <span class="hvr">from</span> <span class="hvr">each</span> <span class="hvr">eye) as a single image. This</span> <span class="hvr">results</span> in <span class="hvr">depth</span> <span class="hvr">perception, helping us to see the world in glorious 3D. To recreate this in VR apps, you need to render two very slightly different views side by side, which will be taken in by the left and right eyes when the user is using the HMD.</span></p>

<p><img alt="How to create stereoscopic 3D images" src="https://mdn.mozillademos.org/files/11095/createStereoscopicImages.png" style="width: 100%;"></p>

<h3 id="Head_tracking">Head tracking</h3>

<p>The primary technology used to make you feel present in a 360º scene, thanks to the gyroscope, accelerometer, and magnetometer (compass) included in the HMD.<br>
 It has primary relevance because it makes our eyes believe we are in front of a spherical screen, giving users realistic immersion inside the app canvas.</p>

<h3 id="Eye_strain">Eye strain</h3>

<p>A term commonly used in VR because it is a major handicap of using an HMD — we are constantly fooling the eye with what we are showing in the app canvas, and this leads to the eyes doing a lot more work than they normally would, so using VR apps for any extended period of time can lead to eye strain.</p>

<p>To minimize this unwanted effect, we need to:</p>

<ul>
 <li>Avoid focusing on different depths (e.g. avoid using a lot of particles with differents depths.)</li>
 <li>Avoid eye convergion (e.g. if you have an object that comes towards the camera your eyes will follow and converge on it.)</li>
 <li>Use darker backgrounds with more subdued colors where possible; a bright screen will make the eyes more tired.</li>
 <li>Avoid rapid brightness changes.</li>
 <li>Avoid presenting the user with large amounts of text to read. You should also be careful with the distance between the eyes/camera and the text to read. 0.5m is uncomfortable, whereas at more than 2m the stereo effect starts to break down, so somewhere in between is advisable.</li>
 <li>Be careful with the distance between objects and the camera in general. Oculus recommends 0.75m as a minimum distance of focus.</li>
 <li>Use a pointer if the user needs to interact with an object in the scene — this will help them point to it correctly with less effort.</li>
</ul>

<p>In general, the path of least visual effort will give the user a less tiring experience.</p>

<h3 id="Motion_sickness">Motion sickness</h3>

<p>If developers do not take utmost care, VR apps can actually cause their users to feel sick. This effect is produced when the stimuli their eyes are receiving is not what the body expects to receive.</p>

<p>To avoid bringing on motion sickness in our users (or at least minimize the effects), we need to:</p>

<ul>
 <li>Always maintain head tracking (this is the most important of all, especially if it occurs in middle of the experience.)</li>
 <li>Use constant velocity; avoid acceleration or decceleration camera movements (use linear acceleration, and avoid vs easing if you can.)</li>
 <li>Keep the framerate up (less than 30fps is uncomfortable.)</li>
 <li>Avoid sharp and/or unexpected camera rotations.</li>
 <li>Add fixed points of reference for fixed objects (otherwise the user will believe they are on the move.)</li>
 <li>Do not use Depth of Field or Motion Blur post processing because you do not know where the eyes will focus.</li>
 <li>Avoid brightness changes (use low frequency textures or fog effects to create smooth lighting transitions).</li>
</ul>

<p>Overall your eyes should not send signals to the brain that cause reflex actions in other parts of the body.</p>

<h3 id="Latency">Latency</h3>

<p>Latency is the time between the physical head movement and the visual display reaching the user's eyes from the screen of an HMD being updated. This is one of the most critical factors in providing a realistic experience. Humans can detect very small delays — we need to keep the latency below 20 milliseconds if they are to be imperceptible (for example a 60Hz monitor has a 16 ms response.)</p>

<p>The Oculus Rift headset has a latency of 20 ms or less, but with mobile device-based setups it will depend heavily on the smartphone CPU power and other capabilities. </p>

<h3 id="Framerate_(_Frames_per_second_FPS_)">Framerate ( Frames per second / FPS )</h3>

<p>Based on the Wikipedia definition, framerate is the frequency at which an imaging device produces unique consecutive images, called frames. A rate of 60fps is an acceptable rate for a smooth user experience, but depending on the performance of the machine the app is running on, or the complexity of the content you want to show, it can drastically lower. Less than 30fps is generally considered jittery, and annoying to the user.</p>

<p>One of the most difficult tasks is to maintain a constant and high framerate value, so we must optimize our code to make it as efficient as possible. It is preferable to have a decent framerate that doesn't constantly or suddenly change; for this you need to as few necessary objects moving into the scene as possible and (in the case of WebGL) try to reduce draw calls. </p>

<h3 id="Interpupillary_distance_(_IPD_)">Interpupillary distance ( IPD )</h3>

<p>Based on the Wikipedia definition, IPD is the distance between the centers of the pupils of the two eyes. IPD is critical for the design of binocular viewing systems, where both eye pupils need to be positioned within the exit pupils of the viewing system.</p>

<p>Interpupillary distace ( IPD ) can be calculated using {{domxref("VREyeParameters.offset")}} in WebVR, which is equal to half the IPD.</p>

<p>This value is returned by the HMD and its value may be around 60 to 70 mm; in the case of some HMDs like Oculus Rift's, you can set your own IPD. Normally we don't change this value but you can play with it to change the scale of the entire scene. For example, if your IPD is set to 6000 mm, the user would view the scene like a giant looking at a Lilliputian world.</p>

<h3 id="Degrees_of_Freedom_(_DoF_)">Degrees of Freedom ( DoF )</h3>

<p>DoF refers to the movement of a rigid body inside space. There is no uniformity in creating acronyms for this term — we can find references to 3DoF in the context of sensors that detect only rotational head tracking, and 6DoF when an input allows us to control position and orientation simultaneously. We even sometimes find 9DoF references when the hardware contains three sensors like gyroscope, accelerometer and magnetometer, but the results of the 3 x 3DoF values will actually return a 6 degrees of freedom tracking.</p>

<p>DoF is directly related to the tracking of the user's head movement.</p>

<h3 id="Cone_of_focus">Cone of focus</h3>

<p>Although our field of view is much larger (approximately 180º), we need to be aware that only in a small portion of that field can you perceive symbols (the center 60º) or read text (the center 10º). If you do not have an eye tracking sensor we assume that the center of the screen is where the user is focusing their eyes.</p>

<p>This limitation is important to consider when deciding where place visuals on the app canvas — too far towards the edge of the cone of focus can lead to eye strain much more quickly. There is a very interesting post about this (amongst other things) at MozVR.com — see <a href="http://mozvr.com/posts/quick-vr-prototypes/">Quick VR Mockups with Illustrator</a>.</p>

<h3 id="3D_Positional_Audio">3D Positional Audio</h3>

<p>3D positional audio refers to a group of effects that manipulate audio to simulate how it would sound in a three dimensional space.</p>

<p>This directly related to the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>, which allows us to place sounds on objects we have in the canvas or launch audio depending on the part of the scene the user is traveling towards or looking at.</p>
